#!/usr/bin/env perl

$gp = "spc.gp";

open ( FILE, ">$gp" );

print FILE <<EOF;
set xrange [ 0.75 : 2.25 ]
set yrange [ 0.00 : 0.50 ]

set xtics 0.2
set ytics 0.1
set mxtics 4
set mytics 2
set format x "%.1f"
set format y "%.1f"

set xlabel "Wavelength (microns)"
set ylabel "I/F"

EOF

foreach $spc ( `ls *.spc` ) {
	chomp ( $spc );
    print FILE "plot '$spc' u (\$1/1000):2:3 w errorl\n";
    print FILE "pause 0.1\n";
}

close ( FILE );
