#!/usr/bin/env perl

# set the absolute paths
$PATH_SPICE_KERNEL = "/home/xxx/kernels";
$PATH_NIRS_BIN     = "/home/xxx/bin"; 

$KERNEL  = "$PATH_SPICE_KERNEL";
$GKERNEL = "$KERNEL/generic_kernels";
$IKERNEL = "$KERNEL/Itokawa";
$HKERNEL = "$KERNEL/HAYABUSA";
$ENV{'PATH_LSK'}           = "$GKERNEL/lsk/naif0009.tls";
$ENV{'PATH_PCK'}           = "$GKERNEL/pck/pck00008.tpc";
$ENV{'PATH_SPK'}           = "$GKERNEL/spk/de405.bsp";
$ENV{'PATH_ITOKAWA_FK'}    = "$HKERNEL/fk/itokawa_fixed.tf";
$ENV{'PATH_ITOKAWA_PCK'}   = "$IKERNEL/pck/itokawa_gaskell.tpc";
$ENV{'PATH_ITOKAWA_PMK'}   = "$IKERNEL/plate/SHAPE0.bpm";
$ENV{'PATH_ITOKAWA_SPK'}   = "$IKERNEL/spk/itokawa_1989-2010.bsp";
$ENV{'PATH_HAYABUSA_CK'}   = "$HKERNEL/ck/hayabusa_itokawarendezvous_v01.bc";
$ENV{'PATH_HAYABUSA_FK'}   = "$HKERNEL/fk/HAYABUSA_HP.TF";
$ENV{'PATH_HAYABUSA_IK'}   = "$HKERNEL/ik/nirs10.ti";
$ENV{'PATH_HAYABUSA_SCLK'} = "$HKERNEL/sclk/hayabusa.tsc";
$ENV{'PATH_HAYABUSA_SPK'}  = "$HKERNEL/spk/hayabusa_itokawarendezvous_v01.bsp";

$ti2et   = "$PATH_NIRS_BIN/ti2et";
$viewgeo = "$PATH_NIRS_BIN/viewgeo";

foreach $fits ( @ARGV ) {
	
    unless ( $fits =~ /\.fits$/ ) {
		print "Usage: command NIRS_FITS\n";
		next; }
	
	$plt = $fits; $plt =~ s/fits/plt/; $plt =~ s/\_lvl1\.0//;

	( $ti_end, $stack, $integ ) =
		split ( /\s+/, `gethead -f $fits TIME STACK INTEG` );
	$et_end = `$ti2et $ti_end`; chomp ( $et_end );
	$et_str = $et_end - (( 65.24*2.0*( 2.0**$stack - 1.0 )) + $integ )*1.0E-03;
	$et_mid = ( $et_str + $et_end ) / 2.0;
	
	system ( "$viewgeo $et_mid > $plt" );

    print "$fits -> $plt\n";
}
