#!/usr/bin/env perl

# set the absolute paths
$PATH_SPICE_KERNEL = "/home/xxx/kernels";

$pix   = 30;     # pixel number of nirs for drawing
$max   = 0.1455; # maximum value of data range
$min   = 0.1265; # minimum value of data range

$shape = "$PATH_SPICE_KERNEL/Itokawa/plate/SHAPE0.dat";
$dat   = "plt.dat";
$inc   = "plt.inc";

@xyz = `awk '{print \$5,\$6,\$7,\$8,\$9,\$10,\$11,\$12,\$13}' $shape`;

$pix += 1;
@ref = `awk '{print \$$pix}' $dat`;
chomp ( @xyz ); chomp ( @ref );
open ( FILE, "> $inc" );

##  color pallet of Rainbow (from PGPLOT)
	@rl = ( -0.50, 0.00, 0.17, 0.33, 0.50, 0.67, 0.83, 1.00, 1.50 );
	@rr = (  0.00, 0.00, 0.00, 0.00, 0.60, 1.00, 1.00, 1.00, 1.00 );
	@rg = (  0.00, 0.00, 0.00, 1.00, 1.00, 1.00, 0.60, 0.00, 1.00 );
	@rb = (  0.00, 0.30, 0.80, 1.00, 0.30, 0.00, 0.00, 0.00, 1.00 );

for ( $i = 1 ; $i <= $#xyz ; $i++ ) {

	( $v0_x, $v0_y, $v0_z, $v1_x, $v1_y, $v1_z, $v2_x, $v2_y, $v2_z )
		= split ( /\s+/, $xyz[$i] );

	$l = $ref[$i];

	if ( $l == 0.0 ) { $l = 1.5; }
	elsif ( $l > $max ) { $l = 1.0; }
	elsif ( $l < $min ) { $l = 0.0; }
	else { $l = ( $l - $min ) / ( $max - $min ); }

	for ( $j = 0 ; $j < $#rl ; $j++ ) {
		if ( $l > $rl[$j] && $l <= $rl[$j+1] ) {
			$lo = $j; $up = $j+1; last; }
	}
	$A = ( $l - $rl[$lo] ) / ( $rl[$up] - $rl[$lo] ) ;
	$B = ( $rl[$up] - $l ) / ( $rl[$up] - $rl[$lo] ) ;
	$r = ( $A * $rr[$up] ) + ( $B * $rr[$lo] );
	$g = ( $A * $rg[$up] ) + ( $B * $rg[$lo] );
	$b = ( $A * $rb[$up] ) + ( $B * $rb[$lo] );
	
	print FILE "polygon{\n  4 , ";
	printf FILE ( "<%.3lf,%.3lf,%.3lf>,", $v0_x, $v0_y, $v0_z );
	printf FILE ( "<%.3lf,%.3lf,%.3lf>,", $v1_x, $v1_y, $v1_z );
	printf FILE ( "<%.3lf,%.3lf,%.3lf>,", $v2_x, $v2_y, $v2_z );
	printf FILE ( "<%.3lf,%.3lf,%.3lf>\n", $v0_x, $v0_y, $v0_z );
	printf FILE ( "  pigment{color rgb<%.5lf,%.5lf,%.5lf>}\n", $r, $g, $b );
	print FILE "}\n\n";
}

close ( FILE );
