#!/usr/bin/env perl

$nplat = 49152; # number of plates

foreach $plt ( `ls *.plt` ) {

	chomp ( $plt );
	$spc = $plt; $spc =~ s/plt/spc/;
	
	@plt_info = `awk '{print \$1,\$2}' $plt`;
	chomp ( @plt_info ); shift ( @plt_info );
	@spc_info = `awk '{print \$2}' $spc`;
	chomp ( @spc_info ); shift ( @spc_info );

	$S = 0;
	foreach ( @plt_info ) {
		( $pid, $s ) = split ( /\s+/, $_ );
		$S += $s; }
	
	for ( $i = 0 ; $i <= $#plt_info ; $i++ ) {
		( $pid, $s ) = split ( /\s+/, $plt_info[$i] );

		for ( $j = 0 ; $j < 64 ; $j++ ) {
			$ref = $spc_info[$j];
			$tot_ref[$j][ $pid ] += ( $ref*$s/$S );
		}
		$tot_fra[ $pid ] += ( $s / $S );
		$tot_num[ $pid ]++;
	}

	undef ( @plt_info ); undef ( @spc_info );
}

open ( FILE, "> plt.dat" );
printf FILE ( "# plate-id, total-num-obs, ave-ref (1-64)\n" );

for ( $i = 1 ; $i <= $nplat ; $i++ ) {
	printf FILE ( "%d %d", $i, $tot_num[$i] );
	if ( $tot_fra[$i] == 0.0 ) {
		for ( $j = 0 ; $j < 64 ; $j++ ) {
			printf FILE ( " %13.6e", 0.0 );
		}
	} else {
		for ( $j = 0 ; $j < 64 ; $j++ ) {
			printf FILE ( " %13.6e", ( $tot_ref[$j][$i] / $tot_fra[$i] ));
		}
	}
	printf FILE ( "\n" );
}
close ( FILE );
