#include <stdio.h>
#include <stdlib.h>
#include "SpiceUsr.h"

#define prec 6     // Digits of precision in fractional seconds or days.
#define lenout 30  // The length of the output string plus 1.

int main ( int argc, char **argv ) {

  SpiceChar   *LSK;
  SpiceChar   *HAYABUSA_SCLK;

  SpiceChar   *sclkch;
  SpiceDouble sc = -130;
  SpiceDouble et;
  SpiceChar   *utc;
  utc = ( SpiceChar * ) malloc ( lenout * sizeof ( SpiceChar ) );

  if ( getenv ( "PATH_LSK" ) == NULL ) {
    fprintf ( stderr, "not defined $PATH_LSK\n" );
    exit ( 1 );
  }
  if ( getenv ( "PATH_HAYABUSA_SCLK" ) == NULL ) {
    fprintf ( stderr, "not defined $PATH_HAYABUSA_SCLK\n" );
    exit ( 1 );
  } 
  
  LSK  = getenv ( "PATH_LSK" );
  HAYABUSA_SCLK= getenv ( "PATH_HAYABUSA_SCLK" );

  furnsh_c ( LSK );
  furnsh_c ( HAYABUSA_SCLK );
  
  if ( argc != 2 ) {
    fprintf ( stderr, "Usage:%s spacecraft_clock_time[dec]\n", argv[0] );
    exit ( 1 ); }
  
  sclkch = argv[1];
  scs2e_c ( sc, sclkch, &et );

  printf ( "%.4lf\n", et );
	  
  return ( 0 );
}
